package org.processmining.glueminer.dialogs;

import javax.swing.JComponent;

import org.processmining.framework.util.ui.widgets.ProMPropertiesPanel;
import org.processmining.framework.util.ui.wizard.ProMWizardStep;
import org.processmining.glueminer.parameters.GeneratePetrinetConstants;
import org.processmining.glueminer.parameters.GeneratePetrinetParameters;

import com.fluxicon.slickerbox.components.NiceIntegerSlider;
import com.fluxicon.slickerbox.components.NiceSlider.Orientation;
import com.fluxicon.slickerbox.factory.SlickerFactory;

public class PetrinetGenerationWizardStep extends ProMPropertiesPanel implements ProMWizardStep<GeneratePetrinetParameters> {
	public static String TITLE = "Configure Petri Net generation parameters";

	/**
	 * 	int numStartActivities;
	int numEndActivities;
	int noIntermediateActivities;
	int noOfWantedPlaces;
	int maxNoIterations;
	int maxSourceActivitiesNumber;
	int maxTargetActivitiesNumber; */
	
	NiceIntegerSlider sliderNumStartActivities;
	NiceIntegerSlider sliderNumEndActivities;
	NiceIntegerSlider sliderNumIntermediateActivities;
	NiceIntegerSlider sliderNumWantedPlaces;
	NiceIntegerSlider sliderMaxNoIterations;
	NiceIntegerSlider sliderMaxSourceActivitiesNumber;
	NiceIntegerSlider sliderMaxTargetActivitiesNumber;
	
	public PetrinetGenerationWizardStep(String title) {
		super(title);
		// TODO Auto-generated constructor stub
	}
	
	public PetrinetGenerationWizardStep() {
		super(TITLE);
		
		this.sliderNumStartActivities = SlickerFactory.instance().createNiceIntegerSlider("Number of start activities", GeneratePetrinetConstants.minStartActivities, GeneratePetrinetConstants.maxStartActivities, GeneratePetrinetConstants.defaultStartActivities, Orientation.HORIZONTAL);
		this.sliderNumEndActivities = SlickerFactory.instance().createNiceIntegerSlider("Number of end activities", GeneratePetrinetConstants.minEndActivities, GeneratePetrinetConstants.maxEndActivities, GeneratePetrinetConstants.defaultEndActivities, Orientation.HORIZONTAL);
		this.sliderNumIntermediateActivities = SlickerFactory.instance().createNiceIntegerSlider("Number of intermediate activities", GeneratePetrinetConstants.minIntermediateActivities, GeneratePetrinetConstants.maxIntermediateActivities, GeneratePetrinetConstants.defaultIntermediateActivities, Orientation.HORIZONTAL);
		this.sliderNumWantedPlaces = SlickerFactory.instance().createNiceIntegerSlider("Number of wanted places", GeneratePetrinetConstants.minWantedPlaces, GeneratePetrinetConstants.maxWantedPlaces, GeneratePetrinetConstants.defaultWantedPlaces, Orientation.HORIZONTAL);
		this.sliderMaxNoIterations = SlickerFactory.instance().createNiceIntegerSlider("Max number of iterations", GeneratePetrinetConstants.minMaxNoIterations, GeneratePetrinetConstants.maxMaxNoIterations, GeneratePetrinetConstants.defaultMaxNoIterations, Orientation.HORIZONTAL);
		this.sliderMaxSourceActivitiesNumber = SlickerFactory.instance().createNiceIntegerSlider("Max source activities per place", GeneratePetrinetConstants.minMaxSourceActivitiesNumber, GeneratePetrinetConstants.maxMaxSourceActivitiesNumber, GeneratePetrinetConstants.defaultMaxSourceActivitiesNumber, Orientation.HORIZONTAL);
		this.sliderMaxTargetActivitiesNumber = SlickerFactory.instance().createNiceIntegerSlider("Max target activities per place", GeneratePetrinetConstants.minMaxTargetActivitiesNumber, GeneratePetrinetConstants.maxMaxTargetActivitiesNumber, GeneratePetrinetConstants.defaultMaxTargetActivitiesNumber, Orientation.HORIZONTAL);

		this.add(this.sliderNumStartActivities);
		this.add(this.sliderNumEndActivities);
		this.add(this.sliderNumIntermediateActivities);
		this.add(this.sliderNumWantedPlaces);
		this.add(this.sliderMaxNoIterations);
		this.add(this.sliderMaxSourceActivitiesNumber);
		this.add(this.sliderMaxTargetActivitiesNumber);
	}

	public GeneratePetrinetParameters apply(GeneratePetrinetParameters model, JComponent component) {
		// TODO Auto-generated method stub
		
		GeneratePetrinetParameters parameters = new GeneratePetrinetParameters(this.sliderNumStartActivities.getValue(), this.sliderNumEndActivities.getValue(), this.sliderNumIntermediateActivities.getValue(), this.sliderNumWantedPlaces.getValue(), this.sliderMaxNoIterations.getValue(), this.sliderMaxSourceActivitiesNumber.getValue(), this.sliderMaxTargetActivitiesNumber.getValue());
		return parameters;
	}

	public boolean canApply(GeneratePetrinetParameters model, JComponent component) {
		// TODO Auto-generated method stub
		return true;
	}

	public JComponent getComponent(GeneratePetrinetParameters model) {
		// TODO Auto-generated method stub
		return this;
	}

	public String getTitle() {
		// TODO Auto-generated method stub
		return TITLE;
	}

}
