package org.processmining.glueminer.models;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class Behavior {
	public String variant;
	public int variantCount;
	public List<Transition> enabledTransitions;
	public Map<String, Transition> activitiesTransitions;
	
	public Behavior(String variant, Map<String, Transition> activitiesTransitions) {
		this.enabledTransitions = new ArrayList<Transition>();
		this.activitiesTransitions = activitiesTransitions;
		this.variant = variant;
		this.variantCount = 0;
	}
	
	public void increase() {
		this.variantCount++;
	}
	
	public String getVariant() {
		return this.variant;
	}
	
	public int getVariantCount() {
		return this.variantCount;
	}
	
	public void buildEnabledTransitions() {
		String[] activitiesInVariant = variant.split(",");
		
		for (String activity : activitiesInVariant) {
			enabledTransitions.add(activitiesTransitions.get(activity));
		}
	}
	
	public void printResume() {
		System.out.println("count: "+variantCount+" variant: "+variant);
	}
}
